extends Node

const min_x = 10
const max_x = 220
const min_y = 10
const max_y = 160
const item_scenes = [
	preload("res://items/Apple.tscn"),
	preload("res://items/Book2.tscn"),
	preload("res://items/Book.tscn"),
	preload("res://items/Cash.tscn"),
	preload("res://items/Clothing1.tscn"),
	preload("res://items/Clothing2.tscn"),
	preload("res://items/Item1.tscn"),
	preload("res://items/Item2.tscn"),
	preload("res://items/Item3.tscn"),
	preload("res://items/Knife.tscn"),
	preload("res://items/Pan.tscn"),
	preload("res://items/Pot.tscn"),
]

var is_in_game = false
var level = 3
var items_thrown_away = []
var max_score = 0;

var current_rank = 0;

		
var base_joy_total_negative_joy = 0;

func _ready():
	start_game()

func _process(delta):
	$Player/Joydar/Bars/Bar/Gauge.value = $Player.get("joy") * 100
	$GameStatus/MarginContainer/Time/Label.text = str(int($Timer.time_left) + 1)

func start_game():
	while $Items.get_child_count() > 0:
		$Items.remove_child($Items.get_child(0))
	items_thrown_away = []
	$Player.position = Vector2(118, 8)
	
	# spawn 15 good items
	for i in range(5): 
		var item_joy =  0.5 + randf() * 0.5
		max_score += item_joy
		spawn_item(randi() % len(item_scenes), item_joy)
	
	
	# keep creating items until we reach 0 joy in room.
	
	var sum = 0;
	while sum < max_score:
		var item_joy = randf() * 0.5
		sum += item_joy
		
		if (sum + item_joy > max_score):
			continue
		if (base_joy_total_negative_joy < item_joy):
			base_joy_total_negative_joy = item_joy
		spawn_item(randi() % len(item_scenes), item_joy)
	
	
	
	#for i in range(len(item_scenes)): #range(2 + level * 3):
	#	var item_scenes_i = 
	#	spawn_item(i)
	
	$Player/Joydar.show()
	$GameStatus/MarginContainer.show()
	$GameOver/MarginContainer.hide()
	$Timer.start()
	is_in_game = true
	$GameStatus/MarginContainer/Emotion.set_emotion(0)

func end_game():
	$Timer.stop()
	var items_in_room = $Items.get_children()
	var joy_in_room = total_joy_in_items(items_in_room)
	var joy_thrown_away = total_joy_in_items(items_thrown_away)
	print(joy_in_room)
	print(joy_thrown_away)
	level += 1
	
	# calculate your rank out of six
	var rank = joy_in_room / max_score;
	$GameOver/MarginContainer/Emotion.set_emotion(rank)
	print(rank)
	if rank >= (5.0 / 6):
		$GameOver/MarginContainer/Hi.text = "You've sparked joy!"
	elif rank >= (4.0 / 6):
		$GameOver/MarginContainer/Hi.text = "Pretty happy :)"
	elif rank >= (3.0 / 6):
		$GameOver/MarginContainer/Hi.text = "Not too shabby!"
	elif rank >= (2.0 / 6):
		$GameOver/MarginContainer/Hi.text = "Ok"
	elif rank >= (1.0 / 6):
		$GameOver/MarginContainer/Hi.text = "Not so great :/"
	else:
		$GameOver/MarginContainer/Hi.text = "Hmm..."

	$Player/Joydar.hide()
	$GameOver/MarginContainer.show()
	$GameStatus/MarginContainer.hide()
	is_in_game = false

func game_over():
	level = 0
	print("game over")

func spawn_item(item_scenes_i, joy):
	var item = item_scenes[item_scenes_i].instance()
	item.position = Vector2(
		min_x + randf() * max_x,
		min_y + randf() * max_y
	)
	var item_joy = joy
	item.set("joy", item_joy)
	$Items.add_child(item)

func throw_away_item(item):
	$Items.remove_child(item)
	items_thrown_away.append(item)
	
	var items_in_room = $Items.get_children()
	var joy_in_room = total_joy_in_items(items_in_room)
	# calculate your rank out of six
	#var rank = int(floor(joy_in_room / max_score * 6));
	$GameStatus/MarginContainer/Emotion.set_emotion(joy_in_room / max_score)

func total_joy_in_items(items):
	var joy = 0
	for item in items:
		if (item.get("joy") < 0.5):
			joy -= item.get("joy")
		else:
			joy += item.get("joy")
	return joy

func _on_Timer_timeout():
	end_game()